config/routes.rb
Scrapbook::Engine.routes.draw do
  resources :masters do
    collection do
      get :search
    end
  end
  resources :placements
end

app/models/scrapbook/application_record.rb
module Scrapbook
  class ApplicationRecord < ActiveRecord::Base
    self.abstract_class = true
  end
end

app/models/scrapbook/master.rb
module Scrapbook
  class Master < ApplicationRecord
    has_attached_file :file,
      styles: { large: '800x800>', square_thumb: '250x250#' }
    do_not_validate_attachment_file_type :file

    has_many :placements, dependent: :destroy,
                          foreign_key: :scrapbook_master_id,
                          after_add: :copy_file_to_placement

    before_save :extract_resolution
    attribute :image_resolution, :scrapbook_resolution

    def all_metadata
      attributes.select { |k, v| self.class.metadata_fields.include?(k) }
    end

    def metadata
      all_metadata.select { |k, v| v.present? }
    end

    def metadata=(hsh)
      assign_attributes(hsh)
    end

    def file=(attr)
      return if file.exists?
      file.assign(attr)
    end

    def copy_file_to_placement(placement)
      placement.file = file
    end

    def self.keyword_search(term, fields = searchable_fields)
      query_string = fields
                     .map { |fn| "#{fn}::varchar ILIKE :term" }
                     .join(' OR ')
      where(query_string, term: "%#{term}%")
    end

    def title
      self[:title].present? ? self[:title] : file_file_name
    end

    def image?
      file_content_type =~ %r{^(image|(x-)?application)/(bmp|gif|jpeg|jpg|pjpeg|png|x-png)$}
    end

    private

    def self.metadata_fields
      Scrapbook.config.metadata_fields.keys
    end

    def self.searchable_fields
      metadata_fields.prepend(:title)
    end

    def extract_resolution
      return if !image? || file.blank?
      tempfile = file.queued_for_write[:original]
      return if tempfile.nil?
      self.image_resolution = Paperclip::Geometry.from_file(tempfile).to_s
    end
  end
end

app/models/scrapbook/placement.rb
module Scrapbook
  class Placement < ApplicationRecord
    belongs_to :master, foreign_key: :scrapbook_master_id,
                        inverse_of: :placements,
                        class_name: 'Scrapbook::Master'

    belongs_to :parent, polymorphic: true, touch: true,
                        inverse_of: :scrapbook_placements,
                        required: false # Temporarily dont require parent?

    default_scope { sorted }
    scope :context, ->(context) { where(context_name: context) }
    scope :sorted, -> { order(:position) }

    delegate :target_resolution, to: :context, prefix: false
    delegate :aspect_ratio, to: :target_resolution, prefix: false

    delegate :title, to: :master, prefix: false, allow_nil: true
    delegate :metadata, to: :master, prefix: true
    delegate :all_metadata, to: :master, prefix: true

    attribute :crop_origin, :scrapbook_coordinate, default: '0,0'
    attribute :crop_resolution, :scrapbook_resolution

    validates_presence_of :context_name

    has_attached_file :file,
      styles: lambda { |attachment| attachment.instance.sizes },
      processors: Scrapbook.config.paperclip_processors

    do_not_validate_attachment_file_type :file

    before_save :recrop_check

    def initialize(attributes)
      attributes ||= {}
      super context_name: attributes.delete(:context_name)
      assign_attributes(attributes)
    end

    def context
      Context.find(context_name)
    end

    def recrop_check
      return unless crop_changed? && !new_record?
      self.file.assign(self.file)
      file.save
    end

    def sizes
      sizes = { standard: target_resolution.to_s }
      sizes[:retina] = target_resolution.retinafy.to_s if crop_retina_ready?
      sizes
    end

    def crop_retina_ready?
      usable_crop_resolution.retinable?(target_resolution)
    end

    def crop_metrics
      {
        width: usable_crop_resolution.width,
        height: usable_crop_resolution.height,
        x: crop_origin.x,
        y: crop_origin.y
      }
    end

    def overriding_metadata
      attributes.select do |k, v|
        self.class.metadata_fields.include?(k) && v.present?
      end
    end

    def overriding_metadata=(hsh)
      assign_attributes(hsh)
    end

    def metadata
      master_metadata.merge(overriding_metadata)
    end

    def all_metadata
      master_all_metadata.merge(overriding_metadata)
    end

    def usable_crop_resolution
      crop_resolution || target_resolution
    end

    def file_urls
      Hash[sizes.keys.map { |size| [size, file_url(size)] }]
    end

    def file_url(style = :standard)
      return '' unless file
      file.url(style)
    end

    def edit_path
      @edit_path ||= Engine.routes.url_helpers.edit_placement_path(self)
    end

    def to_data
      as_json(methods: [:edit_path, :file_urls, :title, :metadata], except: [:crop_origin, :crop_resolution])
    end

    def crop_changed?
      crop_resolution_changed? || crop_origin_changed?
    end

    def master=(other)
      super
      self.file = master.file
    end

    def scrapbook_master_id=(other_id)
      super
      self.file = master.file
    end

    private

    def self.metadata_fields
      Scrapbook.config.metadata_fields.keys
    end

  end
end

app/controllers/scrapbook/application_controller.rb
module Scrapbook
  class ApplicationController < ActionController::Base
    helper_method :placing?

    if Scrapbook.config.before_action
      before_action Scrapbook.config.before_action
    end

    def url_options
      { :context => params[:context] }.merge(super)
    end

    def placing?
      params[:context].present?
    end
  end
end

app/controllers/scrapbook/masters_controller.rb
require_dependency "scrapbook/application_controller"

module Scrapbook
  class MastersController < ApplicationController
    before_action :find_master, only: %i[show edit update destroy]

    def index
      @masters = Master.all
    end

    def search
      @masters = Master.keyword_search(params[:q])
      render :index
    end

    def show; end

    def new
      @master = Master.new
    end

    def edit; end

    def create
      @master = Master.new(master_params)

      if @master.save
        destination = placing? ? new_placement_path(master: @master) : @master
        redirect_to destination, notice: I18n.t('masters.saved')
      else
        render :new, error: I18n.t('errors.general')
      end
    end

    def update
      if @master.update(master_params)
        redirect_to masters_path, notice: I18n.t('masters.saved')
      else
        render :edit, error: I18n.t('errors.general')
      end
    end

    def destroy
      if @master.destroy
        redirect_to masters_path, alert: I18n.t('masters.destroyed')
      else
        redirect_to @master, error: I18n.t('errors.general')
      end
    end

    private

    def find_master
      @master = Master.find(params[:id])
    end

    def master_params
      params.require(:master)
            .permit(:title, :file, :taken_on, metadata_field_names)
    end

    def metadata_field_names
      Scrapbook.config.metadata_fields.keys
    end
  end
end

app/controllers/scrapbook/placements_controller.rb
require_dependency "scrapbook/application_controller"

module Scrapbook
  class PlacementsController < ApplicationController
    before_action :find_placement, only: [:show, :edit, :update, :destroy]

    def index
      @placements = Placement.all
    end

    def show
    end

    def new
      @master = Master.find(params[:master])
      @placement = Placement.new(context_name: params[:context])
    end

    def edit
      @master = @placement.master
    end

    def create
      @placement = Placement.new(placement_params)
      if @placement.save
        redirect_to placement_path(@placement),
                    notice: I18n.t('placements.saved')
      else
        render :new, error: I18n.t('errors.general')
      end
    end

    def update
      if @placement.update(placement_params.except(:context_name))
        redirect_to placement_path(@placement),
                    notice: I18n.t('placements.saved')
      else
        render :edit, error: I18n.t('errors.general')
      end
    end

    def destroy
      if @placement.destroy
        redirect_to placements_path, alert: I18n.t('placements.destroyed')
      else
        redirect_to @placement, error: I18n.t('errors.general')
      end
    end

    private
    def find_placement
      @placement = Placement.find(params[:id])
    end

    def placement_params
      params.require(:placement).permit(:title, :crop_origin, :crop_resolution,
        :scrapbook_master_id, :context_name, metadata_field_names)
    end

    def metadata_field_names
      Scrapbook.config.metadata_fields.keys
    end
  end
end

app/helpers/scrapbook/library_helper.rb
module Scrapbook
  # View helpers for in-engine views
  module LibraryHelper
    def metadata_fields
      Scrapbook.config.metadata_fields.values
    end

    def freehand_cropping?
      current_context.target_resolution.width_only?
    end

    def free_crop_ratios
      [[3, 2], [4, 3], [5, 4], [16, 9], [1, 1]]
    end

    def current_context
      return unless context_source

      Context.find(context_source)
    end

    def hint_text(translation_name, context = current_context, **options)
      return unless placing?
      t_opts = { context: context.title,
                 file_type_category: context.file_type_category }.merge(options)
      translation = t(translation_name, t_opts)

      content_tag :p, translation, class: 'hint-text'
    end

    private

    def context_source
      return params[:context] if placing?
      return @placement.context_name if @placement
    end
  end
end

app/helpers/scrapbook/public_helper.rb
module Scrapbook
  # View helpers for general parent application views
  module PublicHelper
    def scrapbook_image_tag(placement, **options)
      standard_url = placement&.file_url(:standard)
      return if standard_url.blank?

      default_options = {
        alt: placement.metadata['alt_text'],
        data: placement.metadata
      }
      if placement.crop_retina_ready?
        retina_url = placement.file_url(:retina)
        default_options[:srcset] = "#{retina_url} 2x"
      end
      image_tag standard_url, default_options.merge(options)
    end
  end
end

app/views/scrapbook/masters/_form.html.erb
<%= render 'scrapbook/shared/header' %>
<%= form_for @master do |f| %>
<%= hint_text 'masters.upload_hint' %>
  <div class="master-image-edit">
    <% if @master.file.exists? %>
      <%= image_tag @master.file.url(:large), class: 'master-large' %>
    <% else %>
      <%= f.file_field :file, id: 'files', class: 'inputfile' %>
      <label for="files">
        <figure>
          <svg xmlns="http://www.w3.org/2000/svg" width="125" height="120" viewBox="0 0 20 17"><path id="upload-icon" d="M10 0l-5.2 4.9h3.3v5.1h3.8v-5.1h3.3l-5.2-4.9zm9.3 11.5l-3.2-2.1h-2l3.4 2.6h-3.5c-.1 0-.2.1-.2.1l-.8 2.3h-6l-.8-2.2c-.1-.1-.1-.2-.2-.2h-3.6l3.4-2.6h-2l-3.2 2.1c-.4.3-.7 1-.6 1.5l.6 3.1c.1.5.7.9 1.2.9h16.3c.6 0 1.1-.4 1.3-.9l.6-3.1c.1-.5-.2-1.2-.7-1.5z"></path></svg>
        </figure>
        <span>Upload an Image</span>
      </label>
    <% end %>
  </div>
  <div class="master-info-edit">
    <%= f.label :title, "Title" %>
    <%= f.text_field :title %><br>
    <%= render 'metadata_fields', f: f %>
    <%= f.submit "Save" %>
  </div>
<% end %>

app/views/scrapbook/masters/_master.html.erb
<li class="block">
  <div class="card">
    <div class="card-image">
      <%= link_to_if placing?,
                  image_tag(master.file.url(:square_thumb)),
                  new_placement_path(master: master) %>
    </div>
    <div class="card-header">
      <%= link_to master.title, master, alt: "View" %>
    </div>
  </div>
</li>

app/views/scrapbook/masters/_metadata_fields.html.erb
<% metadata_fields.each do |field| %>
  <%= f.label field.name, field.label %>
  <%= f.send field.form_type, field.name,
             class: field.name %><br>
<% end %>

app/views/scrapbook/masters/_search_form.html.erb
<%= form_tag search_masters_path(format: :js), method: :get, remote: true,
             class: 'search-bar', role: 'search' do %>
  <%= search_field_tag :q, '', placeholder: 'Search' %>
  <%= submit_tag "Search" %>
  <%= button_tag "Reset", type: :reset,
                 onclick: "$.get('#{masters_path(format: :js)}')", class: 'hollow' %>
<% end %>

app/views/scrapbook/masters/edit.html.erb
<%= render 'form' %>

app/views/scrapbook/masters/index.html.erb
<%= render 'scrapbook/shared/header' %>
<%= hint_text 'placements.create_hint' %>

<nav class='masters-heading'>
  <div class="controls">
    <%= link_to "Upload", new_master_path, class: 'button green' %>
  </div>
  <div class="search">
    <%= render 'search_form' %>
  </div>
</nav>
<ul id="masters">
  <%= render @masters %>
</ul>

app/views/scrapbook/masters/index.js.erb
var container = $('#masters');
var masters = '<%= j render(@masters) %>';

container.fadeOut('10', function(){
  $(this).html(masters).fadeIn('50');
});

app/views/scrapbook/masters/new.html.erb
<%= render 'form' %>

app/views/scrapbook/masters/show.html.erb
<%= render 'scrapbook/shared/header' %>

<div class="master-image">
<ul class="accordion-tabs-minimal">
  <li class="tab-header-and-content">
    <a href="#" class="tab-link is-active">Image</a>
    <div class="tab-content">
      <%= image_tag @master.file.url(:large), class: 'master-large' %>
      <hr>
      <%= content_tag :span, @master.image_resolution, class: 'file-info' %>
      <%= content_tag :span, @master.file_content_type, class: 'file-info' %>
      <%= content_tag :span, number_to_human_size(@master.file_file_size),
                      class: 'file-info' %>
      <br>
      <%= link_to "View original file", @master.file.url, target: '_blank' %>
    </div>
  </li>
  <li class="tab-header-and-content">
    <a href="#" class="tab-link">
      <%= pluralize @master.placements.count, 'Placement' %>
    </a>
    <div class="tab-content master-placements">
      <% if @master.placements.any? %>
        <ul>
          <% @master.placements.each do |placement| %>
            <li>
              <%= link_to edit_placement_path(placement)  do %>
                <%= placement.context_name.titleize %> on
                <%= placement.parent.class %>
                <br>
                <%= scrapbook_image_tag placement, width: 200 %>
              <% end %>
            </li>
          <% end %>
        </ul>
      <% else %>
        <%= content_tag :h2, 'No placements yet.' %>
      <% end %>
    </div>
  </li>
</ul>
<%= link_to "Delete Master Image", master_path(@master), method: :delete,
            'data-confirm': t('masters.destroy_confirm'),
             class: 'button red hollow' %>
</div>

<div class="master-info">
  <%= content_tag :h1, @master.title, class: 'master-title' %>
  <%= link_to "Edit", edit_master_path(@master), class: 'button hollow right small' %>
  <%= content_tag :dl do %>
    <% @master.all_metadata.each_pair do |name, value| %>
    <div class="meta-pair">
      <%= content_tag :dt, name.titleize, class: 'meta-name' %>
      <%= content_tag :dd, raw(value), class: "meta-value" %>
    </div>
    <% end %>
    <div class="meta-pair">
      <%= content_tag :dt, 'Created At', class: 'meta-name' %>
      <%= content_tag :dd, time_tag(@master.created_at), class: "meta-value" %>
    </div>

  <% end %>
  <hr>
  <%= link_to "Create #{current_context.full_title}",
              new_placement_path(master: @master),
              class: 'button green' if placing? %>

</div>